import { ReflectedAttrToProps } from '../../_global/types';
import { BootstrapClass } from '../bootstrap-element';
export interface BaseUICustomElement<T = {}> {
    onAbort(ev: UIEvent): void;
    onActivate(this: HTMLElement, ev: Event): any;
    onBeforeactivate(this: HTMLElement, ev: Event): any;
    onBeforecopy(this: HTMLElement, ev: Event): any;
    onBeforecut(this: HTMLElement, ev: Event): any;
    onBeforedeactivate(this: HTMLElement, ev: Event): any;
    onBeforepaste(this: HTMLElement, ev: Event): any;
    onBlur(ev: FocusEvent): void;
    onCanplay(ev: Event): void;
    onCanplaythrough(ev: Event): void;
    onChange(ev: Event): void;
    onClick(ev: MouseEvent): void;
    onContextmenu(ev: PointerEvent): void;
    onCopy(ev: ClipboardEvent): void;
    onCuechange(ev: Event): void;
    onCut(ev: ClipboardEvent): void;
    onDblclick(ev: MouseEvent): void;
    onDeactivate(this: HTMLElement, ev: Event): any;
    onDrag(ev: DragEvent): void;
    onDragend(ev: DragEvent): void;
    onDragenter(ev: DragEvent): void;
    onDragleave(ev: DragEvent): void;
    onDragover(ev: DragEvent): void;
    onDragstart(ev: DragEvent): void;
    onDrop(ev: DragEvent): void;
    onDurationchange(ev: Event): void;
    onEmptied(ev: Event): void;
    onEnded(this: HTMLElement, ev: Event): any;
    onError(ev: ErrorEvent): void;
    onFocus(ev: FocusEvent): void;
    onInput(ev: Event): void;
    onInvalid(ev: Event): void;
    onKeydown(ev: KeyboardEvent): void;
    onKeypress(ev: KeyboardEvent): void;
    onKeyup(ev: KeyboardEvent): void;
    onLoad(ev: Event): void;
    onLoadeddata(ev: Event): void;
    onLoadedmetadata(ev: Event): void;
    onLoadstart(ev: Event): void;
    onMousedown(ev: MouseEvent): void;
    onMouseenter(ev: MouseEvent): void;
    onMouseleave(ev: MouseEvent): void;
    onMousemove(ev: MouseEvent): void;
    onMouseout(ev: MouseEvent): void;
    onMouseover(ev: MouseEvent): void;
    onMouseup(ev: MouseEvent): void;
    onMousewheel(ev: WheelEvent): void;
    onMscontentzoom(this: HTMLElement, ev: Event): any;
    onMsmanipulationstatechanged(ev: Event): void;
    onPaste(ev: ClipboardEvent): void;
    onPause(ev: Event): void;
    onPlay(ev: Event): void;
    onPlaying(ev: Event): void;
    onProgress(ev: ProgressEvent): void;
    onRatechange(ev: Event): void;
    onReset(ev: Event): void;
    onScroll(ev: UIEvent): void;
    onSeeked(ev: Event): void;
    onSeeking(ev: Event): void;
    onSelect(ev: UIEvent): void;
    onSelectstart(ev: Event): void;
    onStalled(ev: Event): void;
    onSubmit(ev: Event): void;
    onSuspend(ev: Event): void;
    onTimeupdate(ev: Event): void;
    onVolumechange(ev: Event): void;
    onWaiting(ev: Event): void;
}
/**
 * custom element base class
 * below methods available to make this base element flexible
 *  - define('element-name') this will help register customElement only if it is not already deinfined
 *  - willConnect() this will be triggered before connectedCallback()
 *  - onConnect() this will be triggered on connectedCallback()
 *  - didConnect() this will be triggered only once after didRender()
 *  - willRender() will be triggered before render()
 *  - didRender() will be triggered after render()
 *  - setState() this helps shallow merge changes and allow re-render
 */
export declare class BaseUICustomElement<T = {}> extends BootstrapClass {
    [key: string]: any;
    static get is(): string;
    static get observedAttributes(): string[];
    static readonly attrToProp: ReflectedAttrToProps;
    static withShadowDom: boolean;
    static elementName: string;
    static define(elementName: string, options?: ElementDefinitionOptions | undefined): void;
    state: T;
    isFirstRender: boolean;
    isCreated: boolean;
    shouldRender: boolean;
    constructor();
    connectedCallback(): void;
    attributeChangedCallback(attrName: string, oldVal: string, newVal: string): void;
    handleEvent(e: Event): void;
    disconnectedCallback(): void;
    protected willConnect(): void;
    protected onConnect(): void;
    protected onDisconnect(): void;
    protected didConnect(): void;
    protected willRender(): void;
    protected render(properties: this): void;
    protected didRender(): void;
    protected setState(state: Partial<T> | ((this: this, state: T) => Partial<T>), render?: boolean): void;
    private afterRender;
    private create;
    private hasRequiredAttributes;
    private beforeRender;
}
export default BaseUICustomElement;
